%define oname   dose3

Summary: Framework for managing distribution packages and their dependencies
Name:    ocaml-%{oname}
Version: 4.2
Release: %mkrel 4
# Intentionaly not using the macros as if you don't change the number in the URL
# you get a tarball of the old version named as the new one
Source0: https://gforge.inria.fr/frs/download.php/file/35465/dose3-4.2.tar.gz
License: LGPLv2 with linking exception
Group:   Development/OCaml
Url:     http://www.mancoosi.org/software/

BuildRequires: ocaml-compiler
BuildRequires: ocaml-findlib
BuildRequires: ocaml-extlib-devel
BuildRequires: ocaml-pcre-devel
BuildRequires: ocaml-re-devel
BuildRequires: ocaml-camlp4-devel
# BuildRequires: ocaml-sqlite-devel ocaml-json-static
BuildRequires: ocaml-camlbz2-devel
BuildRequires: ocaml-camlzip-devel
BuildRequires: ocaml-expat-devel
BuildRequires: ocaml-benchmark-devel
BuildRequires: ocaml-ocamlgraph-devel
BuildRequires: ocaml-curl-devel
BuildRequires: ocaml-xml-light-devel
BuildRequires: ocaml-ounit-devel
BuildRequires: librpm-devel
BuildRequires: ocaml-cudf-devel
BuildRequires: curl-devel
BuildRequires: ocaml-cppo
Requires: ocaml-extlib
Requires: ocaml-pcre
Requires: ocaml-camlbz2-devel
Requires: ocaml-camlzip-devel
Requires: ocaml-expat
Requires: ocaml-curl
Requires: ocaml-ounit
Requires: ocaml-ocamlgraph
Requires: ocaml-cudf
Requires: librpm-devel


%description
Dose3 is a framework made of several OCaml libraries for
managing distribution packages and their dependencies.

Though not tied to any particular distribution, dose3 constitutes a pool of
libraries which enable analyzing packages coming from various
distributions.

Besides basic functionalities for querying and setting package properties,
dose3 also implements algorithms for solving more complex problems
(monitoring package evolutions, correct and complete dependency resolution,
repository-wide uninstallability checks).

%package        devel
Summary:        Development files for %{name}
Group:          Development/OCaml
Requires:       %{name} = %{version}-%{release}

%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.
Requires: ocaml-extlib-devel
Requires: ocaml-pcre-devel
Requires: ocaml-expat-devel
Requires: ocaml-curl-devel
Requires: ocaml-ounit-devel
Requires: ocaml-ocamlgraph-devel
Requires: ocaml-cudf-devel


%prep
%setup -q -n %{oname}-%{version}
%autopatch -p1

%build
./configure --libdir=%{_libdir} \
            --with-xml \
            --with-curl \
            --with-ocamlgraph \
            --with-zip \
            --with-oUnit \
            --with-bz2 \
            --with-rpm4
#            --with-sqlite \
make

%check
# Tests fail for some reason
# make test

%install
make install LIBDIR=%{buildroot}/%{_libdir}/ocaml BINDIR=%{buildroot}/%{_bindir}
rm -f %{buildroot}/%{_libdir}/ocaml/dose3/*.{cm,}o
rm -f %{buildroot}/%{_libdir}/ocaml/dose3/*.ml{.depends,}
cd doc/manpages
for man in *.?; do
    install -m644 $man -D %{buildroot}%{_mandir}/man1/$man
done
cd ../..
cp META %{buildroot}%{_libdir}/ocaml/dose3

# Fix dangling links
rm -f %{buildroot}%{_bindir}/rpmcheck
rm -f %{buildroot}%{_bindir}/debcheck
rm -f %{buildroot}%{_bindir}/eclipsecheck
ln -s %{_bindir}/distcheck %{buildroot}%{_bindir}/rpmcheck
ln -s %{_bindir}/distcheck %{buildroot}%{_bindir}/debcheck
ln -s %{_bindir}/distcheck %{buildroot}%{_bindir}/eclipsecheck

%files
%dir %{_libdir}/ocaml/dose3
%doc COPYING
%{_bindir}/apt-cudf
%{_bindir}/ceve
%{_bindir}/challenged
%{_bindir}/deb-buildcheck
%{_bindir}/deb-coinstall
%{_bindir}/debcheck
%{_bindir}/distcheck
%{_bindir}/dominators-graph
%{_bindir}/eclipsecheck
%{_bindir}/outdated
%{_bindir}/rpmcheck
%{_bindir}/smallworld
%{_bindir}/strong-deps
%{_mandir}/man1/apt-cudf.1*
%{_mandir}/man1/apt-cudf-get.8*
%{_mandir}/man1/apt-cudf.conf.5*
%{_mandir}/man1/ceve.1*
%{_mandir}/man1/challenged.1*
%{_mandir}/man1/deb-buildcheck.1*
%{_mandir}/man1/debcoinstall.1.*
%{_mandir}/man1/distcheck.1*
%{_mandir}/man1/outdated.1*
%{_mandir}/man1/smallworld.1*
%{_mandir}/man1/strongdeps.1*
%{_libdir}/ocaml/dose3/META
%{_libdir}/ocaml/dose3/*.cma
%{_libdir}/ocaml/dose3/*.cmi
%{_libdir}/ocaml/dose3/*.cmxs
%{_libdir}/ocaml/stublibs/*.so*

%files devel
%doc README.architecture TODO
%{_libdir}/ocaml/dose3/*.a
%{_libdir}/ocaml/dose3/*.cmxa


%changelog
* Tue Sep 27 2016 pterjan <pterjan> 4.2-4.mga6
+ Revision: 1057035
- Rebuild for changed signature in ocamlgraph

* Mon Sep 26 2016 pterjan <pterjan> 4.2-3.mga6
+ Revision: 1056325
- Rebuild for fix in ocaml

* Tue Feb 23 2016 pterjan <pterjan> 4.2-2.mga6
+ Revision: 977426
- Rebuild for new ocaml-re

* Mon Feb 08 2016 pterjan <pterjan> 4.2-1.mga6
+ Revision: 950714
- Fix file list
- Fix BuildRequires
- Really update to 4.2
- Update to 4.2

* Sun Sep 06 2015 tv <tv> 3.1.3-7.mga6
+ Revision: 873299
- rebuild with new rpm

* Wed Oct 15 2014 umeabot <umeabot> 3.1.3-6.mga5
+ Revision: 747103
- Second Mageia 5 Mass Rebuild

* Wed Oct 08 2014 tv <tv> 3.1.3-5.mga5
+ Revision: 737463
- patch 3 :fix build with rpm-4.12
- use %%autopatch

  + umeabot <umeabot>
    - Mageia 5 Mass Rebuild

* Sat Oct 19 2013 umeabot <umeabot> 3.1.3-4.mga4
+ Revision: 526533
- Mageia 4 Mass Rebuild

* Tue Jun 04 2013 malo <malo> 3.1.3-3.mga4
+ Revision: 437230
- add patch to fix manpage generation

* Sat Jan 12 2013 umeabot <umeabot> 3.1.3-2.mga3
+ Revision: 361288
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Thu Jan 03 2013 malo <malo> 3.1.3-1.mga3
+ Revision: 338248
- new version 3.1.3

* Thu Jan 03 2013 malo <malo> 3.0.2-6.mga3
+ Revision: 338230
- add patch to fix build due to wrong ocamlbuild for-pack directive

  + tv <tv>
    - rebuild for new rpm

  + blue_prawn <blue_prawn>
    - patch to use extlib-1.5.3
    - new rpm group for ocaml
    - new rpm group for ocaml

  + fwang <fwang>
    - rebuild for new pcre

* Fri Sep 14 2012 malo <malo> 3.0.2-2.mga3
+ Revision: 293883
- fix dangling links (mga#7448)

* Sun Sep 02 2012 malo <malo> 3.0.2-1.mga3
+ Revision: 287316
- new version 3.0.2
- add missing requires for the devel package

* Sat Aug 04 2012 malo <malo> 2.9.10-5.mga3
+ Revision: 278501
- fix requires and buildrequires

* Sun Jun 10 2012 tv <tv> 2.9.10-4.mga3
+ Revision: 259382
- rebuild for new rpm-4.10.0

* Sat Feb 18 2012 malo <malo> 2.9.10-3.mga2
+ Revision: 210169
- renaming requires to ocaml-cudf

* Fri Feb 17 2012 malo <malo> 2.9.10-2.mga2
+ Revision: 210100
- missing requires

* Tue Feb 07 2012 malo <malo> 2.9.10-1.mga2
+ Revision: 205652
- new version 2.9.10
- spec clean-up
- updated file install and list
- new version 2.9.9

* Thu Oct 27 2011 malo <malo> 2.9.8-1.mga2
+ Revision: 158716
- Missing BuildRequires
- new version 2.9.8
- spec rewrite

* Tue Apr 12 2011 ennael <ennael> 2.9.2-2.2457.2.mga1
+ Revision: 83709
- remove deps on dose2

* Tue Apr 12 2011 ennael <ennael> 2.9.2-2.2457.1.mga1
+ Revision: 83661
- fix release tag
- remove rpm5 patch
- clean mdv macros
- imported package ocaml-dose3


* Mon Apr 11 2011 Antoine Ginies <aginies@mandriva.com> 2.9.2-2.2457.1
+ Revision: 652649
- add dot support

* Mon Apr 11 2011 Antoine Ginies <aginies@mandriva.com> 2.9.2-1.2457.1
+ Revision: 652599
- dont use rpm5 patches for old distribution

* Mon Apr 11 2011 Antoine Ginies <aginies@mandriva.com> 2.9.2-0.2457.2
+ Revision: 652592
- bump the release
- add priority missing propriety
- fix build with ocaml-sqlite-devel

* Mon Apr 11 2011 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.9.2-0.2457.1
+ Revision: 652535
- add 'camlp4' to buildrequires
- track down all build dependencies and finally fix the build *phew*
- update to latest code from svn
- redo rpm5 patch
- update description

* Thu Jan 27 2011 Per Øyvind Karlsen <peroyvind@mandriva.org> 1.4.2-1
+ Revision: 633235
- fix path
- work around parallel build breaking
- license is GPLv3+, not GPLv2+
- add rpm5 support (P0)
- updated and improved packaging by Dupuy Mathieu <mdupuy@mandriva.com>

  + Oden Eriksson <oeriksson@mandriva.com>
    - rebuild

* Fri Jul 31 2009 Funda Wang <fwang@mandriva.org> 2.0-0.20070622.4mdv2010.0
+ Revision: 405033
- rebuild

* Wed Mar 04 2009 Guillaume Rousse <guillomovitch@mandriva.org> 2.0-0.20070622.3mdv2009.1
+ Revision: 348614
- rebuild for latest ocaml
- fix ocaml lib directory

* Wed Jan 02 2008 Olivier Blin <oblin@mandriva.com> 2.0-0.20070622.2mdv2008.1
+ Revision: 140728
- restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request

  + Per Øyvind Karlsen <peroyvind@mandriva.org>
    - fix typo

* Sat Jun 23 2007 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.0-0.20070622.2mdv2008.0
+ Revision: 43457
- build and package tart

* Fri Jun 22 2007 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.0-0.20070622.1mdv2008.0
+ Revision: 43262
- compile with %%{optflags}
- fix buildrequires
- fix buildrequires
- compile with -fPIC
- dot
- fix install
- Import edos-dose

